;Routine to toss program memory (+ extra allocated memory optionally) to xms
;when executing a child process.
;
;Written for Masm 6.0 using the .386 assembler directive
;
;You will need one of the many texts around that explain the concepts involved,
;(like Memory Control Block - MCB),a copy of Ralph Brown's Interupt list
;would be helpful as well.  However, if you use this file as is, it will work
;provided you load the xms interupt address into the xm variable declared below.
;See Ralph's list to find out how.  This file is intended to be used as an
;include file.  The include statement should be one of the 1st in your program's
;startup routines.  The point of entry (via jmp command) is "runit:" below.  The
;routine will jump to "aldone:" when it is finished unless the xms interupt
;returns an error condition in which case the jump is to "thasa1".
;
;The following data are declared in the code segment
;to have them available while program memory is trimmed.
.code
;
;these are command line strings and should be loaded before entering this routine
dos     db      "c:\command.com",51 dup (0);if command processor needs to be loaded
head1   db      " /c "                ;command.com switch
head0   db      122 dup (0)           ;path & name of program to load
tail0   db      122 dup (0)           ;command line to pass to above program
;
;parameter blocks to pass to the DOS interupt to execute the child process.
;They should be loaded before entering this routine.
param   dw      3 dup (0),fcb1,0,fcb2,0
fcb1    db      0,"           ",4 dup (0)
fcb2    db      0,"           ",4 dup (0)
;
;other necessary data
xhandle dw      0                     ;xms handle for allocated xms
xmpara  dw      8 dup (0)             ;parameter block for xms interupt
xm      dd      0                     ;xms interupt address
pspmcb  dw      0                     ;segment of psp passed at parent program startup
basemem dw      0                     ;segment of 1st mcb
buffer  db      6 dup (0)             ;to load first 6 bytes of MCB
psplen  dw      0                     ;lenght of main block of RAM assigned to parent

;Must have a stack in code segment.  Best to switch SS at program startup and
;leave it.  But you can use this as a temporary stack and switch every time
;a child process is run if you prefer.
stakk   dw      2000 dup (0)
segm    dw      0                     ;store DS here before entering routine

MCBFIND macro
        mov     ah,52h                ;get ptr to DOS lists
        int     21h                   ;  in es:bx
        mov     es,es:[bx-2]          ;get 1st mcb segment from list
        mov     basemem,es
        endm
mcbtoss label   near
        xor     bp,bp
        push    xmpara[12]
        push    xmpara[14]
        mov     es,basemem
        mov     ax,xhandle
        mov     bx,cs
        mov     ds,bx
        mov     xmpara[2],0           ;high word # bytes to transfer
        mov     xmpara[4],0           ;source is lower memory
        mov     xmpara[6],0           ;low word of source
        mov     xmpara[10],ax         ;xms handle (destination)
        mov     ebx,16
        jmp     seg1st
nxseg:  mov     di,es:[bp+1]
        mov     ebx,16
        cmp     di,0
        je      seg1st
        cmp     di,8
        je      seg1st
        cmp     di,pspmcb
        jne     seg1st
        mov     bx,es:[bp+3]
        inc     ebx
        mov     cl,4
        shl     ebx,cl
seg1st: push    ebx
        mov     xmpara[0],bx          ;low word # of bytes to transfer
        mov     cl,16
        shr     ebx,cl
        mov     xmpara[2],bx
        pop     ebx
        mov     ax,es
        mov     xmpara[8],ax          ;segment address (high word) of source
        mov     si,offset xmpara
        mov     ah,0bh
        call    xm
        cmp     ax,1
        jne     thasa1
        mov     ax,bx
        mov     cl,16                 ;must do here because shr affects carry
        shr     ebx,cl                ;flag
        add     xmpara[12],ax         ;low word of destination
        adc     xmpara[14],bx         ;high word of destination
        cmp     di,pspmcb
        jne     notoh
        mov     ax,es
        inc     ax
        cmp     ax,pspmcb             ;is this your psp block?
        jne     @f
        mov     ax,es:[bp+3]          ;size of memory block
        mov     psplen,ax
;This routine is set for a parent program size of 3840 paragraphs or
;61440 bytes.  You will need to determine this value for your program and
;adjust accordingly.  Use DOS interupt 21, service 4ah to adjust the size
;of your program's memory allocation before entering this routine.
;"Resident size" & "resident size + 1 mcb" should not need to be adjusted
;if you have included this code very early in your source.
;However, if you change these two values, you will also need to change the
;resident program size in bytes below.
        mov     word ptr es:[bp+3],375;resident program size=6000 bytes
        push    es
        mov     bx,es
        add     bx,376                ;resident size + 1 mcb
        mov     es,bx
        mov     byte ptr es:[bp],77   ;create new memory block
        mov     word ptr es:[bp+1],0  ;make it unowned
;This value will need to be adjusted for your program size.  It is:  Number
;of paragraphs your program occupies minus the "resident size + 1 mcb" above.
;In this case:  3840-376=3464
        mov     word ptr es:[bp+3],3464;this is the size of the new memory block
        pop     es
        jmp     notoh
@@:     mov     word ptr es:[bp+1],0  ;release all program mcb's except psp
notoh:  cmp     byte ptr es:[bp],4dh  ;signature ok
        jne     nmor
        mov     bx,es
        inc     bx
        cmp     bx,pspmcb
        jne     @f
        add     bx,psplen
        jmp     flsiz
@@:     add     bx,es:[bp+3]          ;compute next mcb position
flsiz:  mov     es,bx
        jmp     nxseg
nmor:   pop     xmpara[8]             ;high word of source
        pop     xmpara[6]             ;low word of source
        retn
mcbget  label   near
        mov     es,basemem
        mov     ax,xhandle
        mov     xmpara[2],0           ;high word bytes to transfer
        mov     xmpara[4],ax          ;xms handle (source)
        mov     xmpara[10],0          ;destination is low memory
ntseg:  mov     xmpara[0],6           ;low word # bytes to transfer
        mov     xmpara[2],0           ;high word # bytes to transfer
        mov     ax,offset buffer
        mov     xmpara[12],ax         ;low word of destination
        mov     xmpara[14],cs         ;high word of destination
        mov     si,offset xmpara
        mov     ah,0bh
        call    xm
        cmp     ax,1
        jne     thasa1
        mov     ebx,16
        mov     cx,word ptr buffer[1] ;owner of memory block
        cmp     cx,0                  ;0=unassigned
        je      mcbonl                ;8=owned by DOS
        cmp     cx,8                  ;otherwise, segment of owner
        je      mcbonl
        cmp     cx,pspmcb             ;does your program own this block?
        jne     mcbonl
        mov     bx,word ptr buffer[3] ;size of memory block
        inc     ebx
        mov     cl,4
        shl     ebx,cl
        mov     ax,es
        inc     ax
        cmp     ax,pspmcb
        jne     mcbonl
        sub     ebx,16
        mov     eax,6000              ;resident program size in bytes
        sub     ebx,eax
        mov     xmpara[12],ax
        push    xmpara[6]             ;low word of source
        push    xmpara[8]             ;high word of source
        add     xmpara[6],ax
        adc     xmpara[8],0
        mov     ax,psplen
        mov     word ptr es:[bp+3],ax ;size of memory block
        jmp     pspsg
mcbonl: mov     xmpara[12],0
pspsg:  push    ebx
        mov     xmpara[0],bx
        mov     cl,16
        shr     ebx,cl
        mov     xmpara[2],bx
        pop     ebx
        mov     xmpara[14],es
        mov     ah,0bh
        mov     si,offset xmpara
        call    xm
        cmp     ax,1
        jne     thasa1
        mov     ax,word ptr buffer[1] ;owner of memory block
        cmp     ax,pspmcb
        jne     @f
        xor     ebx,ebx
        mov     bx,word ptr buffer[3]
        inc     ebx
        mov     cl,4
        shl     ebx,cl
        mov     ax,es
        inc     ax
        cmp     ax,pspmcb
        jne     @f
        pop     xmpara[8]
        pop     xmpara[6]
@@:     mov     ax,bx
        mov     cl,16
        shr     ebx,cl
        add     xmpara[6],ax          ;low word of source
        adc     xmpara[8],bx          ;high word of source
        mov     cx,es
        add     cx,word ptr buffer[3] ;compute next mcb position
        inc     cx                    ;move forward one paragraph
        mov     es,cx
        cmp     buffer[0],4dh         ;signature of memory block
        je      ntseg                 ;77d=member of chain
        retn                          ;90d=end of chain

runit:  push    dx                    ;Entry Point for this routine
        mov     ax,cs
        mov     ds,ax
        mov     ah,8                  ;how much is free?
        call    xm
;Including the two extra allocated portions of RAM, my program is a little less
;than 167k:  61440 bytes + 41520 bytes + 65536 bytes.  I have added a little
;extra just to be sure.  You will need to adjust your allocation accordingly.
        cmp     dx,167                ;increase this with every 64 paragraphs
        jb      thasa1                ;increase in total program size.
        mov     ah,9
        mov     dx,167                ;allocate memory
        call    xm
        cmp     ax,1
        jne     thasa1
;*****************This portion is optional************************************
        mov     xhandle,dx
        mov     xmpara[0],0           ;# of bytes to transfer
        mov     xmpara[2],1           ;=65536 bytes
        mov     xmpara[4],0           ;source is lower memory
        mov     xmpara[6],0           ;low word of source
        mov     xmpara[8],fs          ;segment address (high word) source
        mov     xmpara[10],dx         ;xms handle (destination)
        mov     xmpara[12],0          ;low word of destination
        mov     xmpara[14],0          ;offset of destination
        mov     si,offset xmpara      ;copy from lower to xms
        mov     ah,0bh
        call    xm
        cmp     ax,1
        jne     thasa1
        mov     xmpara[0],41520
        mov     xmpara[2],0
        mov     xmpara[8],gs
        mov     xmpara[12],2
        mov     xmpara[14],1
        mov     si,offset xmpara
        mov     ah,0bh
        call    xm
        cmp     ax,1
        jne     thasa1
        add     xmpara[12],41520
        mov     ax,gs
        mov     es,ax
        mov     ah,49h
        int     21h
        mov     ax,fs
        mov     es,ax
        mov     ah,49h                ;release lower memory blocks
        int     21h
;*****************End optional portion****************************************
        mcbfind
        call    mcbtoss
        mov     cx,cs
        mov     es,cx
        pop     dx
        mov     bx,offset param       ;info to pass to program
        mov     ah,4bh
        xor     al,al
        INT     21h                   ;execute program
        pushf
        push    ax
        mcbfind
        call    mcbget
;*****************This portion is optional************************************
        mov     ah,48h
        mov     bx,4096
        int     21h                   ;allocate lower memory blocks
        jc      thasa1
        mov     fs,ax
        mov     ah,48h
        mov     bx,2595
        int     21h
        jc      thasa1
        mov     gs,ax
        mov     dx,xhandle
        mov     xmpara[0],0           ;number of bytes to transfer
        mov     xmpara[2],1           ;=65536 bytes-goes in higher word
        mov     xmpara[4],dx          ;xms handle (source)
        mov     xmpara[6],0           ;low word of source
        mov     xmpara[8],0           ;high word of source
        mov     xmpara[10],0          ;destination is lower memory
        mov     xmpara[12],0          ;high word of destination
        mov     xmpara[14],fs         ;segment goes in higher word
        mov     si,offset xmpara      ;copy from upper to lower
        mov     ah,0bh
        call    xm
        cmp     ax,1
        jne     thasa1
        mov     xmpara[0],41520
        mov     xmpara[2],0           ;If you have not allocated extra
        mov     xmpara[6],2           ;RAM for your program's use,
        mov     xmpara[8],1           ;you do not need this portion.
        mov     xmpara[14],gs
        mov     si,offset xmpara
        mov     ah,0bh
        call    xm
        cmp     ax,1
        jne     thasa1
;*****************End optional portion*************************************************************
        mov     ah,0ah                ;release xms block
        mov     dx,xhandle
        call    xm
        cmp     ax,1
        jne     thasa1
        mov     es,segm
        mov     ds,segm
        jmp     aldone
